<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAnswer ArrayType
 * @subpackage Arrays
 */
class ArrayOfAnswer extends AbstractStructArrayBase
{
    /**
     * The Answer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Answer[]
     */
    public $Answer;
    /**
     * Constructor method for ArrayOfAnswer
     * @uses ArrayOfAnswer::setAnswer()
     * @param \StructType\Answer[] $answer
     */
    public function __construct(array $answer = array())
    {
        $this
            ->setAnswer($answer);
    }
    /**
     * Get Answer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Answer[]|null
     */
    public function getAnswer()
    {
        return isset($this->Answer) ? $this->Answer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAnswer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAnswer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAnswerForArrayConstraintsFromSetAnswer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAnswerAnswerItem) {
            // validation for constraint: itemType
            if (!$arrayOfAnswerAnswerItem instanceof \StructType\Answer) {
                $invalidValues[] = is_object($arrayOfAnswerAnswerItem) ? get_class($arrayOfAnswerAnswerItem) : sprintf('%s(%s)', gettype($arrayOfAnswerAnswerItem), var_export($arrayOfAnswerAnswerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Answer property can only contain items of type \StructType\Answer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Answer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Answer[] $answer
     * @return \ArrayType\ArrayOfAnswer
     */
    public function setAnswer(array $answer = array())
    {
        // validation for constraint: array
        if ('' !== ($answerArrayErrorMessage = self::validateAnswerForArrayConstraintsFromSetAnswer($answer))) {
            throw new \InvalidArgumentException($answerArrayErrorMessage, __LINE__);
        }
        if (is_null($answer) || (is_array($answer) && empty($answer))) {
            unset($this->Answer);
        } else {
            $this->Answer = $answer;
        }
        return $this;
    }
    /**
     * Add item to Answer value
     * @throws \InvalidArgumentException
     * @param \StructType\Answer $item
     * @return \ArrayType\ArrayOfAnswer
     */
    public function addToAnswer(\StructType\Answer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Answer) {
            throw new \InvalidArgumentException(sprintf('The Answer property can only contain items of type \StructType\Answer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Answer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Answer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Answer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Answer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Answer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Answer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Answer
     */
    public function getAttributeName()
    {
        return 'Answer';
    }
}
